"use strict";
var chalk = require("chalk");
exports.usageRoot = "  Usage: graphcool [command]\n  \n    " + chalk.bold('Serverless GraphQL database for frontend developers') + "\n    Read more at https://www.graph.cool/docs/cli\n\n  Commands:\n    auth         Sign up or login\n    create       Create a new project\n    eject        Eject config from Schema format to YAML\n    export       Export database\n    fetch        Fetch newest config for project\n    import       Import data\n    projects     List projects\n    migrate      Apply config changes to project\n    version      Print version\n\n  Run 'graphcool COMMAND --help' for more information on a command.\n";
exports.usageAuth = "  Usage: graphcool auth [options]\n  \n  Sign up or login\n  \n  Options:\n    -t, --token <token>    System token\n    -h, --help             Output usage information\n";
exports.usageCreate = "  Usage: graphcool create [options] [schema]\n  \n  Create a new project (uses graphcool.schema as template if exists)\n  \n  The [schema] argument is optional but can point to any kind of .schema file or URL.\n  \n  Options:\n    -n, --name <name>      Project name\n    -a, --alias <alias>    Project alias (https://api.graph.cool/ENDPOINT/ALIAS)\n    -r, --region <region>  AWS Region (default: us-west-1)\n    -h, --help             Output usage information\n";
exports.usageFetch = "  Usage: graphcool fetch\n  \n  Fetch newest config for project \n  \n  Options:\n    -p, --project-id   Project id to fetch (defaults to project from config)\n    -h, --help         Output usage information\n";
exports.usageProjects = "  Usage: graphcool projects\n  \n  List projects\n  \n  Options:\n    -h, --help         Output usage information\n";
//# sourceMappingURL=usage.js.map