"use strict";
var fs = require("fs");
var os = require("os");
var path = require("path");
function writeSchemaFile(schema, projectId) {
    var schemaWithHeader = "# projectId: \"" + projectId + "\"\n\n" + schema;
    fs.writeFileSync('graphcool.schema', schemaWithHeader);
}
exports.writeSchemaFile = writeSchemaFile;
function readProjectIdFromSchemaFile() {
    var contents = fs.readFileSync('graphcool.schema').toString();
    var matches = contents.match(/# projectId: "([a-z0-9]*)"/);
    if (!matches || matches.length !== 2) {
        throw new Error("graphcool.schema doesn't contain a projectId");
    }
    return matches[1];
}
exports.readProjectIdFromSchemaFile = readProjectIdFromSchemaFile;
var configFilePath = path.join(os.homedir(), '.graphcool');
function readConfig() {
    var configFileContent = fs.readFileSync(configFilePath).toString();
    return JSON.parse(configFileContent);
}
exports.readConfig = readConfig;
function writeConfig(config) {
    fs.writeFileSync(configFilePath, JSON.stringify(config, null, 2));
}
exports.writeConfig = writeConfig;
function deleteConfig() {
    fs.unlinkSync(configFilePath);
}
exports.deleteConfig = deleteConfig;
//# sourceMappingURL=file.js.map